aUF_RangeCheck_M = {};
local aUFR = aUF_RangeCheck_M;

-- Get a reference to aUF by global (old style) or LibStub (Ace3)
local aUF_global = aUF;
local aUF_3 = nil;
if (LibStub("AceAddon-3.0", true)) then
	aUF_3 = LibStub("AceAddon-3.0"):GetAddon("ag_UnitFrames", true)
end
local aUF = aUF_global or aUF_3 or nil;

aUFR.frame = CreateFrame("Frame", "aUF_RangeCheckM_Frame", UIParent);

aUFR.queue = {};
aUFR.queuesize = 0;

function aUFR.FillQueue()
	local n = 0;

	for k, v in pairs(aUF.unitid) do
		for obj, used in pairs(v) do
			if used then 
				if obj.unit ~= "player" then
					n = n + 1
					aUFR.queue[n] = obj;
				end
			end
		end
	end

	aUFR.queuesize = n;
end

function aUFR.TargetInRange(unit)
	--[[
	if CheckInteractDistance(unit, 4) then
		return true
	elseif UnitIsUnit("target", unit) then
		return IsActionInRange(aUFR_aid) == 1;
	end
	]]
	if (type(aUFR_aid) == "string") then
		if (IsSpellInRange(aUFR_aid, unit) == 1) then
			return true
		end
	elseif CheckInteractDistance(unit, 4) then
		return true
	else
		return false
	end
end

function aUFR.UpdateRange(frame)
    if (not UnitIsVisible(frame.unit)) then
        frame.frame:SetAlpha(0.3);
    elseif (aUFR.TargetInRange(frame.unit)) then
		frame.frame:SetAlpha(1);
    else
        frame.frame:SetAlpha(0.6);
    end
end

function aUFR.OnUpdate(self)
	if (aUFR.queuesize == 0) then
		aUFR.FillQueue();
	end
	
	local frame = aUFR.queue[aUFR.queuesize];
	aUFR.queuesize = aUFR.queuesize - 1;
	
	aUFR.UpdateRange(frame);
end

function aUFR.OnEvent(self, event, arg1) 
	if (arg1 == "aUF_RangeCheck_M") then
		ChatFrame1:AddMessage("aUF_RangeCheck_M loaded");
		if (not aUFR_aid) then aUFR_aid = 2 end
	elseif (event == "PLAYER_TARGET_CHANGED") then
		for k,v in pairs(aUF.unitid.target) do
			aUFR.UpdateRange(k);
		end
		-- targettarget unit is not updated yet!
		--[[
		for k,v in pairs(aUF.unitid.targettarget) do
			aUFR.UpdateRange(k);
		end
		]]
	else
		ChatFrame4:AddMessage(event .. ": " .. tostring(arg1));
	end
end

if (aUF) then
	aUFR.frame:SetScript("OnUpdate", aUFR.OnUpdate);
	aUFR.frame:SetScript("OnEvent", aUFR.OnEvent);
	aUFR.frame:RegisterEvent("ADDON_LOADED");
	aUFR.frame:RegisterEvent("PLAYER_TARGET_CHANGED");
	-- aUFR.frame:RegisterEvent("PLAYER_REGEN_DISABLED");
	-- aUFR.frame:RegisterEvent("PLAYER_ENTERING_WORLD");
else
	ChatFrame1:AddMessage("aUF_RangeCheck_M: Not initializing handlers, can't find ag_UnitFrames");
end